import argparse
import random

import edmond.bot
import edmond.config
import edmond.log


def main():
    argparser = argparse.ArgumentParser()
    argparser.add_argument("-c", "--config", default="config.json")
    args = argparser.parse_args()

    random.seed()

    logger = edmond.log.get_logger(name="edmond")
    config = edmond.config.load_config(args.config, logger=logger)
    bot = edmond.bot.Bot(config, logger)
    bot.run()


if __name__ == "__main__":
    main()
