import random

from edmond.plugin import Plugin


class BeersPlugin(Plugin):

    REQUIRED_CONFIGS = ["commands", "beers", "opening_text", "target_word"]

    def __init__(self, bot):
        super().__init__(bot)

    def on_pubmsg(self, event):
        if not self.should_handle_command(event.arguments[0]):
            return False

        target = event.source.nick
        if self.command.content:
            words = self.command.content.split(maxsplit=1)
            if len(words) == 2 and words[0] == self.config["target_word"]:
                target = words[1]

        beer = random.choice(self.config["beers"])
        opening_text = self.config["opening_text"].format(
            beer=beer, target=target
        )
        self.bot.say(event.target, opening_text)
        return True
